codeforces 217A 连通块的个数

来源:互联网 发布:极乐净土三人动作数据 编辑:程序博客网 时间:2024/06/09 05:21
题目:

A. Ice Skating
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Bajtek is learning to skate on ice. He's a beginner, so his only mode of transportation is pushing off from a snow drift to the north, east, south or west and sliding until he lands in another snow drift. He has noticed that in this way it's impossible to get from some snow drifts to some other by any sequence of moves. He now wants to heap up some additional snow drifts, so that he can get from any snow drift to any other one. He asked you to find the minimal number of snow drifts that need to be created.

We assume that Bajtek can only heap up snow drifts at integer coordinates.

Input

The first line of input contains a single integer n (1 ≤ n ≤ 100) — the number of snow drifts. Each of the following n lines contains two integers xi and yi (1 ≤ xi, yi ≤ 1000) — the coordinates of the i-th snow drift.

Note that the north direction coinсides with the direction of Oy axis, so the east direction coinсides with the direction of the Ox axis. All snow drift's locations are distinct.

Output

Output the minimal number of snow drifts that need to be created in order for Bajtek to be able to reach any snow drift from any other one.

Examples
input
22 11 2
output
1
input
22 14 1
output
0

给出n个点的横纵坐标,问至少再加几个点可以使得所有的点之间可以通过上下左右走互相到达


思路:

若两个点横坐标或者纵坐标相同,两点间连一条边 通过dfs统计连通块的个数

当然并查集也是可以的,但由于不涉及给出任意两个点判断是否连通,因此dfs更轻便


代码:

dfs:

#include<bits/stdc++.h>#include<queue>using namespace std;const int maxn=120;const __int64 inf=(__int64)1<<62;struct edge {int id;int x;int y;}e[maxn];int g[maxn][maxn];int vis[maxn];int m,ans;void dfs(int x) {vis[x]=1;for(int j=1;j<=m;++j) {if(!vis[j]) if(g[x][j]) dfs(j);}}int main() {//30 ms200 KBscanf("%d",&m);for(int i=1;i<=m;++i) {scanf("%d%d",&e[i].x,&e[i].y);e[i].id=i;}memset(g,0,sizeof(g));for(int i=1;i<=m;++i) {for(int j=1;j<=i;++j) {if(e[i].x==e[j].x||e[i].y==e[j].y) g[i][j]=g[j][i]=1;}}ans=-1;memset(vis,0,sizeof(vis));for(int i=1;i<=m;++i) {if(!vis[i]) dfs(i),ans++;}printf("%d\n",ans);return 0;}



....额 好像只要假装建图就可以了....

#include<bits/stdc++.h>#include<queue>using namespace std;const int maxn=120;const __int64 inf=(__int64)1<<62;struct edge {int x;int y;}e[maxn];int vis[maxn];int m,ans;void dfs(int x) {vis[x]=1;for(int j=1;j<=m;++j) {if(!vis[j]) if(e[x].x==e[j].x||e[x].y==e[j].y) dfs(j);}}int main() {//30 ms100 KBscanf("%d",&m);for(int i=1;i<=m;++i) {scanf("%d%d",&e[i].x,&e[i].y);}ans=-1;memset(vis,0,sizeof(vis));for(int i=1;i<=m;++i) {if(!vis[i]) dfs(i),ans++;}printf("%d\n",ans);return 0;}

并查集实现思路:两个点横后者纵坐标相同就union,最后统计有几个不相交集,即有几个点的fa[i]==i,